Gradle Kotlin DSL
=================

[![TeamCity Build](https://builds.gradle.org/app/rest/builds/buildType:GradleKotlinDSL_Develop/statusIcon.svg)](https://builds.gradle.org/viewType.html?buildTypeId=GradleKotlinDSL_Develop)
[![TravisCI Build](https://img.shields.io/travis/gradle/kotlin-dsl/develop.svg)](https://travis-ci.org/gradle/kotlin-dsl)
[![License](https://img.shields.io/badge/license-Apache%20License%202.0-blue.svg?style=flat)](http://www.apache.org/licenses/LICENSE-2.0)

Welcome! The _Gradle Kotlin DSL_ provides support for writing [Gradle](http://gradle.org) build scripts using JetBrains' [Kotlin](http://kotlinlang.org) language. It aims to provide Gradle users with a rich, flexible and statically-typed approach to developing build logic in conjunction with the best IDE and tooling experience possible.

You can read more about the project in our [announcement blog post](http://gradle.org/blog/kotlin-meets-gradle) and check out the [frequently asked questions](https://github.com/gradle/kotlin-dsl/wiki/Frequently-Asked-Questions) in the project wiki.


Getting Started
---------------

The fastest way to get up and running with a Kotlin-based Gradle build is to work with one of the [samples](samples). You'll find complete instructions in the README there.
There are also some helpful [getting started](doc/getting-started) notes for when your build logic gets more complicated.


Issue Tracking
--------------

Found a bug? Have an idea for an improvement? Feel free to [add an issue](../../issues).

If you're dealing with what you believe to be an issue with Kotlin itself or the Kotlin Plugin for IDEA, you may want to search JetBrains' [YouTrack](https://youtrack.jetbrains.com/issues/KT) first to see if it is a known issue. In any case, feel free to add an issue here for it as well. We'd like to know and track what our users are experiencing regardless whether the issue is with the Gradle Kotlin DSL or with Kotlin itself.


Staying in Touch
----------------

Come chat with us in the #gradle channel of the public [Kotlin Slack](http://slack.kotlinlang.org/) instance.

Limitations
-----------

 * `settings.gradle` cannot yet be written Kotlin, continue to use Groovy there for now.
   
License
-------
Like the rest of Gradle, the _Gradle Kotlin DSL_ is released under version 2.0 of the [Apache License](LICENSE.md).
